# Define templates
include:
  - project: "${GITLAB_CI_TEMPLATES_PATH}"
    file: "${GITLAB_CI_TEMPLATES_FILE}"
    ref: "1.0.3"

# Define stages
stages:
  - build
  - predeploy
  - deploy
  - test
  - publish
  - release
  - upgrade
  - cleanup

# Define global variables
variables:
  P_MAVEN_IMAGE_TAG: "3.6.3-jdk-8-slim"

compile/unit-test:
  stage: build
  extends:
    - .buildJavaMavenTest
  variables:
    MAVEN_PHASE: "clean install"

package:
  stage: build
  extends:
    - .buildJavaMavenPackage
  variables:
    P_MAVEN_EXTRA_ARGS: "-DskipTests"
  needs:
    - job: compile/unit-test
      artifacts: true

install-cache-repo:
  stage: publish
  extends:
    - .publishJavaMavenInstall
  variables:
    P_MAVEN_EXTRA_ARGS: "-DskipTests"
  needs:
    - job: package
      artifacts: true

publish-code:
  stage: publish
  extends:
    - .publishJavaMavenDeploy
  needs:
    - job: package
      artifacts: true

release/code:
  stage: release
  extends:
    - .releaseCodeForJava
  when: manual

